local colony = engine.system.behaviour:new()
      colony.requirements = {
        "colony",
      }

function colony:buildMines(data)
  for k, v in pairs(engine.items.resource) do
    local amt = 1
    local lvl = math.ceil(data.colony.level)
    if engine.planets[data.planet.landType] ~= nil then
      amt = engine.planets[data.planet.landType][k]
    end
    for i = 1, amt do
      game.world:addBuilding(data.id, "mine", k)
    end
  end
end

function colony:buildFactories(data)
  for k, v in pairs(data.colony.inventory) do
    local recipe = engine.items.getRecipe(k)
    local lvl = data.colony.level
    local amt = 1
    if engine.planets[data.planet.landType] ~= nil then
      amt = engine.planets[data.planet.landType][k] or 1
    end
    for i = 1, amt do
      game.world:addBuilding(data.id, "factory", k, engine.items.getTier(k))
    end
    if amt == 1 then
      dbg.add(amt.." "..k.." factory added at colony "..data.id..".", "BUILD")
    else
      dbg.add(amt.." "..k.." factories added at colony "..data.id..".", "BUILD")
    end
  end
end

function colony:clearProductionStats(data)
  for k, v in pairs(data.colony.inventory) do
    data.colony.inventory[k].currentProduction = 0
    data.colony.inventory[k].currentUsage = 0
  end
end

function colony:startup(data)
  --self:buildMines(data)
  self:buildFactories(data)
  data.shipTicker = 0
  return data
end

function colony:update(dt, data)
  if data.colony.updateProduction then
    self:clearProductionStats(data)
    for i = 1, #data.colony.building do
      engine.behaviour[data.colony.building[i].class]:update(dt, data, i)
    end
    for i, v in pairs(data.colony.inventory) do
      local craft = data.colony.inventory[i].currentUsage or 1
      local populus = data.colony.inventory[i].popUsage or 1
      local maxUse = data.colony.inventory[i].maxUsage
      data.colony.inventory[i].usageString = craft + populus.."/"..maxUse
      data.colony.inventory[i].prodString = data.colony.inventory[i].currentProduction.."/"..data.colony.inventory[i].production
    end
    data.colony.updateProduction = false
    data.colony.updateFactories = false
    data.colony.updateMines = false
  end
end

return colony