local popUsage = {
        poor = {
          oxygen = .1,
          energy_wafer = 1,
          victory_meals = .2,
          fabrics = .1,
        },
        trained = {
          oxygen = .1,
          energy_wafer = 2,
          victory_meals = .4,
          fabrics = .2,
          piduino_boards = 1,
          bacon = .1,
        },
        wealthy = {
          oxygen = .1,
          energy_wafer = 2,
          fabrics = 1,
          piduino_boards = 2,
          jewelry = 1,
          construction_materials = 2,
          bacon = 1,
          worm_meat = .1,
        },
      }

local colony = engine.system.behaviour:new()
      colony.requirements = {
        "colony"
      }

function colony:useGoods(data, class)
  for k, v in pairs(popUsage[class]) do
    local usage = data.colony.inventory[k].popUsage
    if data.colony.inventory[k].amt - usage >= 0 then
      data.colony.inventory[k].amt = data.colony.inventory[k].amt - usage
    else
      data.colony.inventory[k].amt = 0
    end
    data.colony.inventory[k].currentUsage = (data.colony.inventory[k].currentUsage + usage) or usage
  end
end

function colony:startup(data)
  for k, _ in pairs(popUsage) do
    for i, v in pairs(popUsage[k]) do
      local amt = (v * data.colony.population[k])
      data.colony.inventory[i].popUsage = math.ceil(data.colony.inventory[i].popUsage + amt)
      data.colony.inventory[i].maxUsage = data.colony.inventory[i].maxUsage + data.colony.inventory[i].popUsage
      dbg.add("Adding "..amt.." "..i.." usage ["..data.colony.inventory[i].maxUsage.."].", "FACTORY")
    end
  end
  return data
end

function colony:update(dt, data)
  if data.colony.updatePopulation then
    self:useGoods(data, "poor")
    self:useGoods(data, "trained")
    self:useGoods(data, "wealthy")
    data.colony.updatePopulation = false
  end
end

return colony