local baseUnit = 100
local minPrice = 10
local maxMultiplier = 2
local profitTweak = 1.1

local colony = engine.system.behaviour:new()
      colony.requirements = {
        "colony"
      }

function colony:update(dt, data, forceUpdate)
  if data.colony.updatePrices or forceUpdate then
    for k, v in pairs(data.colony.inventory) do
      local item = data.colony.inventory[k]
      local amt = item.amt
      local production = item.production
      local price = 0
      local goodsCost = 0
      local mod = 1
      local inflation = data.colony.inventory[k].inflation or 0
      local recipe, output = engine.items.getRecipe(k)
      if not forceUpdate then
        if amt <= data.colony.inventory[k].max / 10 then
          data.colony.inventory[k].inflation = inflation + 1
        else
          data.colony.inventory[k].inflation = 0
        end
      end
      for i = 1, #recipe do
        local goodsPrice = data.colony.inventory[recipe[i].item].price
        goodsCost = goodsCost + (goodsPrice * recipe[i].amt)
      end
      price = goodsCost / output[1].amt
      local supplyMod = engine.math.map(item.amt, 0, item.max + 1000, 1, (maxMultiplier * 1000)) / 1000
      price = math.max(math.ceil(price * (maxMultiplier - supplyMod)), 1)
      if price <= minPrice then
        price = minPrice * (maxMultiplier - supplyMod) + inflation
      end
      data.colony.inventory[k].price = math.ceil(price)
    end
    data.colony.updatePrices = false
  end
end

return colony