local factory = engine.system.behaviour:new()
      factory.requirements = {
        "none"
      }

function factory.checkRecipe(recipe, inv)
  local bool = false
  for i = 1, #recipe do
    if inv[recipe[i].item].amt > recipe[i].amt then
      bool = true
    else
      bool = false
      break
    end
  end
  return bool
end

function factory.useResources(recipe, inv)
  for i = 1, #recipe do
    local item = recipe[i].item
    local amt = recipe[i].amt
    inv[item].amt = inv[item].amt - amt
    inv[item].currentUsage = inv[item].currentUsage + amt
  end
end

function factory.makeProduct(output, inv, pType)
  for i = 1, #output do
    local item = output[i].item
    local amt = output[i].amt
    inv[item].amt = inv[item].amt + amt
    inv[item].currentProduction = inv[item].currentProduction + amt
  end
end

function factory:update(dt, data, id)
  if data.colony.updateFactories then
    local build = data.colony.building[id]
    local recipe, output = engine.items.getRecipe(build.product)
    local inv = data.colony.inventory
    if recipe == nil then
      dbg.add(output, "ERROR")
      return
    end
    if inv[output[1].item].amt + output[1].amt <= inv[output[1].item].max then
      if factory.checkRecipe(recipe, inv) then
        factory.useResources(recipe, inv)
        factory.makeProduct(output, inv, data.planet.landType)
      end
    end
  end
end

return factory