local factory = {}

function factory.new(product, tier)
  return {
    class = "factory",
    product = product,
    tier = tier,
    storage = 500,
    timer = 0,
    productionTime = 120,
    setup = false,
  }
end

function factory.init(data, build)
  local recipe, output = engine.items.getRecipe(build.product)
  if recipe ~= nil then
    for i = 1, #recipe do
      local item = recipe[i].item
      if item ~= nil then
        data.colony.inventory[item].craftUsage = data.colony.inventory[item].craftUsage + recipe[i].amt
        data.colony.inventory[item].maxUsage = data.colony.inventory[item].craftUsage + data.colony.inventory[item].maxUsage
        data.colony.inventory[item].usageString = data.colony.inventory[item].usage + data.colony.inventory[item].popUsage.."/"..data.colony.inventory[item].maxUsage
        dbg.add("Adding "..recipe[i].amt.." "..item.." usage ["..data.colony.inventory[item].maxUsage.."].", "FACTORY")
      end
    end
    for i = 1, #output do
      data.colony.inventory[output[i].item].max = data.colony.inventory[output[i].item].max + build.storage
      data.colony.inventory[output[i].item].amt = data.colony.inventory[output[i].item].amt + (build.storage / 2)
      data.colony.inventory[output[i].item].production = data.colony.inventory[output[i].item].production + output[i].amt
    end
    dbg.add(build.product.." "..build.class.." created at planet "..data.id..".", "BUILD")
  end
end

return factory