local orbit = engine.system.behaviour:extend()
      orbit.requirements = {
              "transform",
              "orbiter",
            }

function orbit:startup(data)
  local parent = game.world:getObjectData(data.orbiter.parentId)
  local parentPos = engine.system.vector:new(parent.transform)
  data.transform.x = parentPos.x + data.transform.x
  data.transform.y = parentPos.y + data.transform.y
  return data
end

function orbit:update(dt, data)
  local parent = game.world:getObjectData(data.orbiter.parentId)
  local parentPos = engine.system.vector:new(parent.transform)
  local rad = data.orbiter.radius
  local ang = data.orbiter.angle + (data.orbiter.angularVelocity * dt)
  local x = rad * math.cos(ang)
  local y = rad * math.sin(ang)
  local offsetx = parentPos.x + data.orbiter.offsetx
  local offsety = parentPos.y - data.orbiter.offsety
  data.transform.x = offsetx + x
  data.transform.y = offsety + y
  data.orbiter.angle = ang
  if data.planet ~= nil then
    data.planet.landRot = data.planet.landRot + data.planet.landInc
    data.planet.atmoRot = data.planet.atmoRot + data.planet.atmoInc
  end
  return data
end

return orbit