local planet = {
  landTypes = {
    "earth",
    "magma",
  },
  atmoTypes = {
    "oxygen",
    "boron",
  },
}

function planet.new(parentId, starId, radius, scale)--, landType, atmoType)
  local landType = planet.landTypes[math.random(1, #planet.landTypes)]
  local atmoType = planet.atmoTypes[math.random(1, #planet.atmoTypes)]
  local size = engine.system.vars.planet.textureSize
  if landInc == 0 then landInc = 1 end
  return {
    type = "planet",
    localStar = starId,
    transform = engine.component.transform.new(0, 0, scale),
    planet = engine.component.planet.new(landType, atmoType, landInc),
    renderer = engine.component.renderer.new(landType, size, size, "fisheye", 0),
    orbiter = engine.component.orbiter.new(parentId, radius),
    resource = engine.component.resource.new(),
  }
end

return planet