local sqrt = math.sqrt
local thruster = engine.system.behaviour:new()
      thruster.requirements = {
        "transform",
        "engine",
        "target",
      }

function thruster:update(dt, data)
  if data.target.id ~= 0 then
    --Get target...
    local tar = game.world:getObjectData(data.target.id)
    
    --Get Distance and Vector...
    local dx, dy = tar.transform.x - data.transform.x, tar.transform.y - data.transform.y
    local dist = sqrt((dx * dx) + (dy * dy))
    local normx, normy = dx / dist, dy / dist
    local acc = data.engine.acc * dt
    local ax = normx * acc
    local ay = normy * acc
    local vx = data.engine.vx
    local vy = data.engine.vy
    local hyp = sqrt((vx * vx) + (vy * vy))
    local tx = vx / hyp
    local ty = vy / hyp
    
    --Determine Speed and acceleration vector...
    if math.abs(dist) > math.abs(data.target.range) and math.abs(vx) > 1 and math.abs(vy) > 1 then
      --data.engine.speed = math.max(data.engine.speed - acc, data.engine.acc)
      ax = (tx * -1) * acc
      ay = (ty * -1) * acc
      data.target.distance = dist
    elseif math.abs(dist) > math.abs(data.target.distance) / 2 then
      --data.engine.speed = data.engine.speed + acc
    elseif math.abs(dist) > math.abs(data.target.distance) / 1000 and data.engine.speed > data.engine.acc then
      --data.engine.speed = math.max(data.engine.speed - acc, data.engine.acc)
      ax = (tx * -1) * acc
      ay = (ty * -1) * acc
    else
      --data.engine.speed = math.max(data.engine.speed - acc, data.engine.acc)
    end
    local mx = vx + ax
    local my = vy + ay
    local mag = math.sqrt((mx * mx) + (my * my))
    
    --Check distance to target...
    local tDist = (tar.renderer.w * tar.transform.scale) / 3
    if math.abs(dx) < tDist and math.abs(dy) < tDist then
      data.target.docked = data.target.id
      data.target.id = 0
      data.engine.speed = 0
      data.engine.vx = 0
      data.engine.vy = 0
      return
    end
    
    --Move the ship...
    data.engine.vx = mx
    data.engine.vy = my
    data.engine.speed = hyp
    data.target.range = dist
    data.transform.x = data.transform.x + (data.engine.vx * dt)
    data.transform.y = data.transform.y + (data.engine.vy * dt)
    data.transform.r = math.deg(math.atan2(ay, ax)) + 90
  else
    local tar = game.world:getObjectData(data.target.docked, "transform")
    data.transform.x = tar.x
    data.transform.y = tar.y
  end
end

return thruster