local btn = engine.ui.button:extend()
      function btn:setup()
        self.isPicture = true
      end

local ships = btn:extend()
      function ships:onClick(x, y, b)
        dbg.add("Test", "CLICK "..engine.currentState)
        if #game.world.players[CURRENT_PLAYER].ships > 1 then
          if engine.state[engine.currentState].ui:windowExists("player_ships") then
            engine.state[engine.currentState].ui:closeWindow("player_ships")
          else
            engine.state[engine.currentState].ui:add("player_ships", engine.window.player_ship_win:new())
          end
        else
          if engine.state[engine.currentState].ui:windowExists("ship_"..CURRENT_SHIP) then
            engine.state[engine.currentState].ui:closeWindow("ship_"..CURRENT_SHIP)
          else
            engine.state[engine.currentState].ui:add("ship_"..CURRENT_SHIP, engine.window.ship_window:new(), CURRENT_SHIP)
          end
        end
      end

local routes = btn:extend()
      function routes:onClick(x, y, b)
        if engine.currentState ~= "route_planner" then
          engine.state.set("route_planner")
        else
          engine.state.set("game")
        end
      end

local menu = engine.ui.container:extend()

function menu:setup()
  self.label = "Menu"
  self:setSize(300, 64)
  self:setPosition(math.floor((engine.screenWidth - self.w) / 2), 0)
  self:setBackground("standard_container")
  self:setHoverColour("standard_container_hover")
  self:add("ships", ships:new("Ships", 10, 5, 32, 32, "ship_window_button", "ship_window_button", {0,0,0,0}, false))
  self:add("routes", routes:new("Routes", self:stackRight("ships", 5), 5, 32, 32, "route_button", "route_button", {0,0,0,0}, false))
  self:centerObject("ships", "v")
  self:centerObject("routes", "v")
  self.isDirty = true
end

function menu:update(dt)
  local x = math.floor((engine.screenWidth - self.w) / 2)
  self:setPosition(x, 0)
end

return menu