local WIDTH = 512
local HEIGHT = 512
local BUTTONWIDTH = 64
local BUTTONHEIGHT = 32
local tab = engine.ui.tab:extend()
local styleSheet = {
        buttons = {
          startX = (WIDTH - 7) - (BUTTONWIDTH + 2),
          startY = 3,
          width = BUTTONWIDTH,
          height = BUTTONHEIGHT,
          offsetX = 0,
          offsetY = 1,
          back = "standard_button",
          hover = "standard_button_hover",
          tCol = engine.system.vars.user.userText,
          tiled = true,
        },
        containers = {
          x = 3,
          y = 3,
          w = (WIDTH - 8) - (BUTTONWIDTH + 3),
          h = HEIGHT - 64,
          back = "standard_container",
          hover = "standard_container_hover",
          tCol = engine.system.vars.user.userText,
          tiled = true,
        },
      }

local travelBtn = engine.ui.button:extend()
      function travelBtn:onClick(x, y, b)
        if game.world.objects[CURRENT_SHIP].target.docked ~= self.win.planetId then
          game.world.players[game.currentPlayer]:moveTo(self.win.planetId)
        end
      end

local win = engine.ui.window:extend()

function win:setup(planetId)
  self.planetId = planetId
  local tCol = engine.system.vars.user.userText
  local data = game.world:getObjectData(planetId)
  self.label = "Planet "..planetId
  self:setPosition(1, 1)
  self:setSize(WIDTH, HEIGHT)
  self:setBackground("standard_window")
  self.isMoveable = true
  self:add("close_button", engine.ui.button:closeBtn(WIDTH - 32, 0))
  self:add("tab_box", tab:new("tab_box", 3, 30, WIDTH - 6, HEIGHT - 58, "standard_container", "standard_container", tCol))
  self:add("goto", travelBtn:new("Set Course", 3, self:stackUnder("tab_box", 1), WIDTH - 6, BUTTONHEIGHT, "standard_button", "standard_button_hover", tCol, true))
  self.objects.tab_box:setStyleSheet(styleSheet)
  self.objects.tab_box:addTab("Info", engine.prefab.planet_info)
  if data.colony ~= nil then
    self.objects.tab_box:addTab("Trade", engine.prefab.trade_box)
    if data.colony.level > 5 then
      self.objects.tab_box:addTab("Ships", engine.prefab.shipyard_box)
    end
  end
  self.objects.tab_box.objects.Info:onOpen()
  --self:add("scale", engine.ui.button.stretchBtn())
  self:setScale(.85, .85)
end

return win