local WIDTH = 512
local HEIGHT = 512
local BLACK = {0,0,0,255}
local BTNIMG = "standard_spreadsheet_tile"
local LEFTPAD = 10
local YPAD = 12
local BTNWIDTH = 64
local BTNHEIGHT = 16

local btn = engine.ui.data_tracker:extend()
      btn:setTileDimensions(32, 16, 96, 16)
      function btn:onClick(x, y, b)
        if not engine.state[engine.currentState].ui:windowExists("ship_"..self.shipId) then
          engine.state[engine.currentState].ui:add("ship_"..self.shipId, engine.window.ship_window:new(), self.shipId)
        end
      end

local win = engine.ui.container:extend()

function win:addButton(x, y, id, comp, key, watch, altValue)
  local b = btn:extend()
        b:setTracker(game.world.objects[id], id, comp, key)
        b:setAltValue(watch, altValue)
  return b:new("none", x, y, BTNWIDTH, BTNHEIGHT, BTNIMG, BTNIMG.."_hover", engine.system.vars.user.userText, true)
end

function win:checkShips()
  self.ships = game.world.players[CURRENT_PLAYER].ships
  self.objects = nil
  self.objects = {}
  local pad = LEFTPAD
  self:add("ship_label", engine.ui.button:new("Ships", pad, YPAD, BTNWIDTH, BTNHEIGHT, BTNIMG.."_hover", BTNIMG.."_hover", engine.system.vars.user.userText, true))
  pad = pad + BTNWIDTH
  self:add("target_label", engine.ui.button:new("Target", pad, YPAD, BTNWIDTH, BTNHEIGHT, BTNIMG.."_hover", BTNIMG.."_hover", engine.system.vars.user.userText, true))
  pad = pad + BTNWIDTH
  self:add("docked_label", engine.ui.button:new("Docked", pad, YPAD, BTNWIDTH, BTNHEIGHT, BTNIMG.."_hover", BTNIMG.."_hover", engine.system.vars.user.userText, true))
  pad = pad + BTNWIDTH
  self:add("speed_label", engine.ui.button:new("Speed", pad, YPAD, BTNWIDTH, BTNHEIGHT, BTNIMG.."_hover", BTNIMG.."_hover", engine.system.vars.user.userText, true))
  for i = 1, #self.ships do
    local y = (BTNHEIGHT * (i - 1)) + (YPAD + BTNHEIGHT)
    local pad = LEFTPAD
    local data = game.world:getObjectData(self.ships[i])
    local shipName = data.class.."_"..i
    self:add(data.class.."_"..i, self:addButton(pad, y, self.ships[i], "name"))
    pad = pad + BTNWIDTH
    self:add("target_"..i, self:addButton(pad, y, self.ships[i], "target", "id", 0, "Landed"))
    pad = pad + BTNWIDTH
    self:add("docked_"..i, self:addButton(pad, y, self.ships[i], "target", "docked", 0, "Inbound"))
    pad = pad + BTNWIDTH
    self:add("speed_"..i, self:addButton(pad, y, self.ships[i], "engine", "speed", 0, "Offline"))
  end
end

function win:setup()
  self.label = "Ships"
  self:setPosition(5, 30)
  self:setSize(WIDTH - 10, HEIGHT - 62)
  self:setBackground("standard_container")
  self:setHoverColour("standard_container_hover")
  self:checkShips()
end

function win:update(dt, x, y)
  if UPDATE_PLAYER_DATA then
    self:checkShips()
    UPDATE_PLAYER_DATA = false
  end
  
end

return win