local BLACK = {0,0,0,255}
local BTNIMG = "standard_spreadsheet_tile"
local MINX = 7
local MINY = 7
local LEFTPAD = MINX
local YPAD = 12
local BTNWIDTH = 64
local BTNHEIGHT = 16
local LABELWIDTH = 2.5

local info = engine.ui.container:extend()

function info:newTracker(x, y, id, comp, key, watch, altValue)
  local b = engine.ui.data_tracker:extend()
        b:setTracker(game.world.objects[id].cargo.hold, 0, comp, key)
        b:setAltValue(watch, altValue)
        b:setTileDimensions(32, 16, 96, 16)
  return b:new("", x, y, BTNWIDTH, BTNHEIGHT, BTNIMG, BTNIMG.."_hover", engine.system.vars.user.userText, true)
end

function info:newLabel(label, x, y, widMod, highlight)
  local img = BTNIMG
  if highlight ~= nil then img = img.."_hover" end
  local b = engine.ui.button:extend()
        b:setTileDimensions(32, 16, 96, 16)
  return b:new(label, x, y, BTNWIDTH * widMod, BTNHEIGHT, img, BTNIMG.."_hover", engine.system.vars.user.userText, true)
end

function info:newLabelRow()
  YPAD = MINY
  local data = engine.items.getData(item)
  LEFTPAD = MINX
  self:add("item", self:newLabel("Item", LEFTPAD, YPAD, LABELWIDTH, true))
  LEFTPAD = LEFTPAD + (BTNWIDTH * LABELWIDTH)
  self:add("amt", self:newLabel("Amt", LEFTPAD, YPAD, 1, true))
  LEFTPAD = LEFTPAD + BTNWIDTH
  self:add("value", self:newLabel("Avg Cost", LEFTPAD, YPAD, 1, true))
end

function info:newRow(ship, item, y)
  if ship.cargo.hold[item] ~= nil then
    local data = engine.items.getData(item)
    LEFTPAD = MINX
    self:add("label_"..item, self:newLabel(data.label, LEFTPAD, y, LABELWIDTH))
    LEFTPAD = LEFTPAD + (BTNWIDTH * LABELWIDTH)
    self:add("amt_"..item, self:newTracker(LEFTPAD, y, ship.id, item, "amt", 0, "none"))
    LEFTPAD = LEFTPAD + BTNWIDTH
    self:add("value_"..item, self:newTracker(LEFTPAD, y, ship.id, item, "value", 0, "none"))
  end
end

function info:checkItems()
  local ship = game.world:getObjectData(self.win.shipId)
  self.objects = nil
  self.drawOrder = nil
  self.objects = {}
  self:newLabelRow()
  YPAD = MINY + BTNHEIGHT
  for k, v in pairs(ship.cargo.hold) do
    self:newRow(ship, k, YPAD)
    YPAD = YPAD + BTNHEIGHT
  end
  self.isDirty = true
end

function info:setup()
  self:checkItems()
end

function info:update(dt)
  local ship = game.world:getObjectData(self.win.shipId)
  if ship.cargo.inventoryChanged then    
    self:checkItems()
    ship.cargo.inventoryChanged = false
    self.isDirty = true
  end
end

return info