local trans = {0,0,0,0}
local pl = engine.ui.container:extend()

local function newHitBox(label, y, w, id, comp, bCol, hCol, tCol)
  local hb = engine.ui.hit_box:extend()
        hb:setBounds(id, comp)
  return hb:new(label, 25, y, w - 50, 16, bCol, hCol, tCol, false)
end

function pl:setup()
  local tCol = engine.system.vars.user.uiText
  local data = game.world:getObjectData(self.win.shipId)
  self:add("camera", engine.ui.entity_camera:new("ship", self.win.shipId, 25, 25, self.w - 50, self.w - 50))
  local y = self:stackUnder("camera", 2)
  self:add("hull_bar", newHitBox("Hull", y, self.w, self.win.shipId, "hull", {255, 0,0,255}, {0,255,0,255}, tCol))
  y = self:stackUnder("hull_bar", 2)
  self:add("armour_bar", newHitBox("Armour", y, self.w, self.win.shipId, "armour", {255, 0,0,255}, {0,0,255,255}, tCol))
  y = self:stackUnder("armour_bar", 2)
  self:add("shield_bar", newHitBox("Shield", y, self.w, self.win.shipId, "shield", {255, 0,0,255}, {255,255,0,255}, tCol))
  game.world.cameras["ship_"..self.win.shipId]:setScale(50)
  self.win.isDirty = true
end

function pl:update(dt)
  self.isDirty = true
end

return pl