local WIDTH = 381
local HEIGHT = 512
local BUTTONWIDTH = 64
local BUTTONHEIGHT = 32
local tab = engine.ui.tab:extend()
local styleSheet = {
        buttons = {
          startX = (WIDTH - 7) - (BUTTONWIDTH + 2),
          startY = 3,
          width = BUTTONWIDTH,
          height = BUTTONHEIGHT,
          offsetX = 0,
          offsetY = 1,
          back = "standard_button",
          hover = "standard_button_hover",
          tCol = engine.system.vars.user.userText,
          tiled = true,
        },
        containers = {
          x = 3,
          y = 3,
          w = (WIDTH - 8) - (BUTTONWIDTH + 3),
          h = HEIGHT - 64,
          back = "standard_container",
          hover = "standard_container_hover",
          tCol = engine.system.vars.user.userText,
          tiled = true,
        },
      }

local viewBtn = engine.ui.button:extend()
      function viewBtn:onClick(x, y, b)
        game.world.cameras.main:setTarget(self.win.shipId)
      end

local win = engine.ui.window:extend()

function win:setup(shipId)
  self.shipId = shipId
  local data = game.world:getObjectData(shipId)
  self.label = "Ship "..shipId
  self:setPosition(1, 1)
  self:setSize(WIDTH, HEIGHT)
  self:setBackground("standard_window")
  self.isMoveable = true
  self:add("close_button", engine.ui.button:closeBtn(WIDTH - 32, 0))
  self:add("tab_box", tab:new("tab_box", 3, 30, WIDTH - 6, HEIGHT - 58, "standard_container", "standard_container", engine.system.vars.user.userText))
  self:add("goto", viewBtn:new("Track", 3, self:stackUnder("tab_box", 1), WIDTH - 6, BUTTONHEIGHT, "standard_button", "standard_button_hover", engine.system.vars.user.userText, true))
  self.objects.tab_box:setStyleSheet(styleSheet)
  self.objects.tab_box:addTab("Info", engine.prefab.ship_info)
  self.objects.tab_box:addTab("Cargo", engine.prefab.cargo_info)
  self.objects.tab_box:addTab("Route", engine.prefab.route_select)
end

function win:onClose()
  game.world:removeCamera("ship_"..self.shipId)
end

return win