return function (label)
  local path = "/Saves/"..label.."/"
  if love.filesystem.exists(path.."objects.lua") then
    game.world = nil
    
    if game.world == nil then
      game.world = engine.system.world:new()
      game.world:loadSystems()
    end
    
    
    game.world.objects = require(path.."objects")
    game.world.systemLists = require(path.."systems")
    game.world.typeLists = require(path.."types")
    game.world.stars = require(path.."stars")
    
    
    local players = require(path.."players")
    for i = 1, #players do
      if players[i] ~= nil then
        local data = players[i]
        game.world:addPlayer(data.name, data.cash, data.home, data.ai)
        for k, v in pairs(game.world.players[i]) do
          if type(v) ~= "function" then
            game.world.players[i][k] = data[k]
          end
        end
        if data.ai ~= "none" then
          game.world.players[i].aiTree = engine.AI[data.ai]:new()
        end
      end
    end
    CURRENT_PLAYER = 1
    CURRENT_SHIP = game.world.players[CURRENT_PLAYER].currentShip
    game.currentPlayer = 1
    engine.state.set("game_load")
  end
end