local WIDTH = 256
local HEIGHT = 209
local BTNHEIGHT = 32
local black = engine.ui.colour.black
local bPic = "standard_button"
local hPic = bPic.."_hover"

local function addLoadButton(label, y)
  local b = engine.ui.button:extend()
        function b:onClick(x, y, b)
          engine.commands.load(label)
        end
  return b:new(label, 5, y + 3, WIDTH - 20, 32, bPic, hPic, engine.system.vars.user.userText, true)
end

local loadBox = engine.ui.container:extend()
      function loadBox:setup()
        local y = 1
        local dir = love.filesystem.getDirectoryItems("/Saves")
        for _, file in pairs(dir) do
          self:add(file, addLoadButton(file, y))
          y = y + 33
        end
      end

local backBtn = engine.ui.button:extend()
      function backBtn:onClick(x, y, b)
        engine.state.set(engine.lastState)
      end

local load_menu = engine.ui.window:extend()

function load_menu:setup()
  for i = 1, 3 do
    if not love.filesystem.exists("/Saves/Save "..i) then
      love.filesystem.createDirectory("/Saves/Save "..i)
    end
  end
  self.label = "Load Game"
  self.saveName = "autosave"
  local cx = (engine.screenWidth - WIDTH) / 2
  local cy = (engine.screenHeight - HEIGHT) / 2
  local wid = math.floor((WIDTH - 15) / 2)
  self:setPosition(cx, cy)
  self:setSize(WIDTH, HEIGHT)
  self:setBackground("standard_window")
  self:add("load_box", loadBox:new("Load Box", 5, self.headerHeight - 2, WIDTH - 10, (BTNHEIGHT * 4) + 12, "standard_container", "standard_container_hover", engine.system.vars.user.userText, true))
  self:add("cancel", backBtn:new("Cancel", 5, self:stackUnder("load_box", 1), WIDTH - 10, 32, bPic, hPic, engine.system.vars.user.userText, true))
end

function load_menu:update(dt)
  local x = (engine.screenWidth - self.w) / 2
  local y = (engine.screenHeight - self.h) / 2
  self:setPosition(x, y)
end

return load_menu