local rBtn = engine.ui.button:extend()
      function rBtn:onClick(x, y, b)
        if game.world ~= nil then
          game.world.isPaused = false
        end
        engine.state.set(engine.lastState)
      end
      
local saveBtn = engine.ui.button:extend()
      function saveBtn:onClick(x, y, b)
        engine.state.set("save")
      end

local loadBtn = engine.ui.button:extend()
      function loadBtn:onClick(x, y, b)
        engine.state.set("load")
      end

local menuBtn = engine.ui.button:extend()
      function menuBtn:onClick(x, y, b)
        engine.state.set("main_menu")
      end

local exitBtn = engine.ui.button:extend()
      function exitBtn:onClick(x, y, b)
        love.event.quit()
      end

local menu = engine.ui.window:extend()
local WIDTH = 300
local HEIGHT = 1

function menu:setup()
  self.label = "Menu"
  local cx = (engine.screenWidth - WIDTH) / 2
  local cy = (engine.screenHeight - HEIGHT) / 2
  local startY = self.headerHeight - 2
  local sp = 1
  self:setPosition(cx, cy)
  self:setSize(WIDTH, HEIGHT)
  self:setBackground("standard_window")
  self:add("return_button", rBtn:new("Return", 5, startY, WIDTH - 10, 32, "standard_button", "standard_button_hover", engine.ui.colour.white, true))
  self:add("save_button", saveBtn:new("Save", 5, self:stackUnder("return_button", sp), WIDTH - 10, 32, "standard_button", "standard_button_hover", engine.ui.colour.white, true))
  self:add("load_button", loadBtn:new("Load", 5, self:stackUnder("save_button", sp), WIDTH - 10, 32, "standard_button", "standard_button_hover", engine.ui.colour.white, true))
  self:add("menu_button", menuBtn:new("Main Menu", 5, self:stackUnder("load_button", sp), WIDTH - 10, 32, "standard_button", "standard_button_hover", engine.ui.colour.white, true))
  self:add("exit_button", exitBtn:new("Quit to OS", 5, self:stackUnder("menu_button", sp), WIDTH - 10, 32, "standard_button", "standard_button_hover", engine.ui.colour.white, true))
end

return menu