local WIDTH = 300
local HEIGHT = 163
local white = engine.ui.colour.white

local eBtn = engine.ui.button:extend()
      function eBtn:onClick(x, y, b)
        love.event.quit()
      end

local menu = engine.ui.window:extend()

function menu.addButton(label, state, yPos)
  local b = engine.ui.button:extend()
        function b:setup()
          self.label = label
        end
        function b:onClick(x, y, b)
          engine.state[state].initialized = false
          engine.state.set(state)
        end
  return b:new(label, 5, yPos, WIDTH - 10, 32, "standard_button", "standard_button_hover", white, true)
end

function menu:setup()
  local spacing = 1
  self.label = "Main Menu"
  self:setPosition(engine.screenWidth / 2, engine.screenHeight / 2)
  self:setSize(WIDTH, HEIGHT)
  self:setBackground("standard_window")
  self:add("new", self.addButton("New Game", "game_load", self.headerHeight - 2))
  self:add("load", self.addButton("Load Game", "load", self:stackUnder("new", spacing)))
  self:add("sprite", self.addButton("Sprite Editor", "sprite_edit", self:stackUnder("load", spacing)))
  self:add("exit", eBtn:new("Exit", 5, self:stackUnder("sprite", spacing), WIDTH - 10, 32, "standard_button", "standard_button_hover", white, true))
end

function menu:update(dt)
  local w, h = self:getSize()
  local x = (engine.screenWidth - w) / 2
  local y = (engine.screenHeight - h) / 2
  self:setPosition(x, y)
end

return menu