local function newRouteIcon(label, y)
  local tCol = engine.system.vars.user.uiText
  local btn = engine.ui.button:extend()
        btn.isPicture = true
        function btn:setup()
          self.routeName = label
        end
        function btn:onClick(x, y, b)
          self.win.selectedRoute = self.routeName
        end
  return btn:new("", 5, y, 16, 16, "file_icon", "file_icon", tCol, false)
end

local function newRouteButton(label, x, y, w)
  local tCol = engine.system.vars.user.uiText
  local btn = engine.ui.button:extend()
        btn:setTileDimensions(32, 16, 96, 16)
        function btn:setup()
          self.align = "left"
          self.routeName = label
        end
        function btn:onClick(x, y, b)
          self.win.selectedRoute = self.routeName
        end
  return btn:new(label, x, y, w, 16, "standard_spreadsheet_tile", "standard_spreadsheet_tile_hover", tCol, true)
end

local function newRouteList(x, y, w, h)
  local box = engine.ui.container:extend()
        function box:setup()
          self.label = "Route List"
          self:setSize(w, h)
          self:setPosition(x, y)
          local routeList = {}
          for k, v in pairs(game.world.players[CURRENT_PLAYER].routes) do
            table.insert(routeList, k)
          end
          table.sort(routeList)
          local wid = self.w - 26
          local y = 5
          if (#routeList * 16) > self.h then
            wid = wid - 32
          end
          for i = 1, #routeList do
            self:add(routeList[i].."_icon", newRouteIcon(routeList[i], y))
            self:add(routeList[i], newRouteButton(routeList[i], self:stackRight(routeList[i].."_icon", 0), y, wid))
            y = y + 16
          end
        end
  return box:new("saved_routes", x, y, w, h, "standard_container", "standard_container_hover", {0,0,0,0}, true)
end

local route = engine.ui.window:extend()

function route:setup()
  self.label = "Load Route"
  self:setSize(310, 100)
  self.manager:centerObject(self.key)
  self.selectedRoute = "none"
  self:setPosition(engine.screenWidth - self.w, 0)
  self:setBackground("standard_window")
  self:add("route_list", newRouteList(5, 30, self.w - 10, 170))
end

function route:update(dt)
  if self.selectedRoute ~= "none" then
    engine.state.route_planner.loadRoute(self.selectedRoute)
  end
end

return route