local starUp = engine.ui.asset:extend()
      function starUp:onClick(x, y, b)
        self.win.manager.currentStarArrayPos = self.win.manager.currentStarArrayPos + 1
        self.win.manager.currentPlanetArrayPos = 1
        self.box.updateStarTarget = true
      end

local starDown = engine.ui.asset:extend()
      function starDown:onClick(x, y, b)
        self.win.manager.currentStarArrayPos = self.win.manager.currentStarArrayPos - 1
        self.win.manager.currentPlanetArrayPos = 1
        self.box.updateStarTarget = true
      end

local starLabel = engine.ui.button:extend()
      function starLabel:update(dt)
        if self.box.updateStarTarget then
          if self.win.manager.currentStarArrayPos > #game.world.stars then
            self.win.manager.currentStarArrayPos = 1
          elseif self.win.manager.currentStarArrayPos < 1 then
            self.win.manager.currentStarArrayPos = #game.world.stars
          end
          local starId = game.world.stars[self.win.manager.currentStarArrayPos]
          self.win.manager.currentStarID = starId
          self.label = game.world.objects[starId].name
          self.isDirty = true
          self.box.updateStarTarget = false
        end
      end

local planetUp = engine.ui.asset:extend()
      function planetUp:onClick(x, y, b)
        self.win.manager.currentPlanetArrayPos = self.win.manager.currentPlanetArrayPos + 1
        self.box.updatePlanetTarget = true
      end

local planetDown = engine.ui.asset:extend()
      function planetDown:onClick(x, y, b)
        self.win.manager.currentPlanetArrayPos = self.win.manager.currentPlanetArrayPos - 1
        self.box.updatePlanetTarget = true
      end

local planetLabel = engine.ui.button:extend()
      function planetLabel:update(dt)
        if self.box.updatePlanetTarget then
          local starId = game.world.stars[self.win.manager.currentStarArrayPos]
          local planetArrayPos = self.win.manager.currentPlanetArrayPos
          local maxPlanets = #game.world.objects[starId].planets
          if planetArrayPos > maxPlanets then
            self.win.manager.currentPlanetArrayPos = 1
            planetArrayPos = 1
          elseif planetArrayPos < 1 then
            self.win.manager.currentPlanetArrayPos = maxPlanets
            planetArrayPos = maxPlanets
          end
          local planetId = game.world.objects[starId].planets[planetArrayPos]
          self.win.manager.currentPlanetID = planetId
          if game.world.objects[planetId].name ~= nil then
            self.label = game.world.objects[planetId].name
          end
          game.world.cameras.main:setTarget(planetId)
          game.world.cameras.main.scale = .05
          self.box.updatePlanetTarget = false
        end
        self.isDirty = true
      end

local addBtn = engine.ui.button:extend()
      function addBtn:onClick(x, y, b)
        engine.state.route_planner.addPlanet(self.win.manager.currentPlanetID)
      end

local nav = engine.ui.container:extend()

function nav:setup(x, y)
  local trans = {0,0,0,0}
  local tCol = engine.system.vars.user.uiText
  local bg = "standard_slider_button"
  local h = 128
  
  self.label = "Navigation"
  self.win.manager.currentStarArrayPos = 1
  self.win.manager.currentPlanetArrayPos = 1
  self.updateStarTarget = true
  self.updatePlanetTarget = true
  
  self:setSize(300, h)
  self:setPosition(x, y)
  self:setBackground("standard_container")
  self:setHoverColour("standard_container_hover")
  self:add("system_label", engine.ui.label:new("Planet Select", 0, 4, self.w, 16, trans, trans, tCol, false))
  
  y = self:stackUnder("system_label", 2)
  self:add("last_star", starDown:new ("last_star", 3, y, 32, 32, bg.."_left", bg.."_left_hover", trans, false))
  self:add("star_name", starLabel:new("test", self:stackRight("last_star", 0), y, self.w - 70, 32, "standard_button", "standard_button_hover", tCol, true))
  self:add("next_star", starUp:new   ("next_star", self:stackRight("star_name", 0), y, 32, 32, bg.."_right", bg.."_right_hover", tCol, false))
  
  y = self:stackUnder("star_name", 2)
  self:add("last_planet", planetDown:new ("last_planet", 3, y, 32, 32, bg.."_left", bg.."_left_hover", trans, false))
  self:add("planet_name", planetLabel:new("test", self:stackRight("last_planet", 0), y, self.w - 70, 32, "standard_button", "standard_button_hover", tCol, true))
  self:add("next_planet", planetUp:new   ("next_planet", self:stackRight("planet_name", 0), y, 32, 32, bg.."_right", bg.."_right_hover", tCol, false))
  
  y = self:stackUnder("planet_name", 2)
  self:add("add_planet", addBtn:new("Add Planet", 3, y, self.w - 6, 32, "standard_button", "standard_button_hover", tCol, true))
  
end

return nav