local function newNameLabel(x, y, w)
  local tCol = engine.system.vars.user.uiText
  local trans = {0,0,0,0}
  local ti = engine.ui.label:extend()
  return ti:new("Route Name:", x, y, w, 32, trans, trans, tCol, true)
end

local function newTextInput(x, y, w)
  local tCol = engine.system.vars.user.uiText
  local ti = engine.ui.input_box:extend()
        function ti:setup()
          self.text = "New Route"
        end
        function ti:update(dt)
          if engine.state.route_planner.refreshLists then
            self.text = engine.state.route_planner.currentName
            self.isDirty = true
          else
            engine.state.route_planner.currentName = self.text
          end
        end
  return ti:new("", x, y, w, 32, "standard_button", "standard_button_hover", tCol, true)
end

local function newSaveButton(y, w)
  local tCol = engine.system.vars.user.uiText
  local saveBtn = engine.ui.button:extend()
        function saveBtn:onClick(x, y, b)
          local planets = engine.state.route_planner.currentList
          local items = engine.state.route_planner.itemList
          local name = engine.state.route_planner.currentName
          if planets == nil then return end
          if items == nil then return end
          game.world.players[CURRENT_PLAYER]:addRoute(name, planets, items)
        end
  return saveBtn:new("Save", 5, y, w, 32, "standard_button", "standard_button_hover", tCol, true)
end

local function newLoadButton(x, y, w)
  local tCol = engine.system.vars.user.uiText
  local loadBtn = engine.ui.button:extend()
        function loadBtn:onClick(x, y, b)
          engine.state.route_planner.ui:add("load_window", engine.window.route_loader:new())
        end
  return loadBtn:new("Load", x, y, w, 32, "standard_button", "standard_button_hover", tCol, true)
end

local route = engine.ui.window:extend()

function route:setup()
  self.label = "Current Route"
  self:setSize(310, 400)
  self:setPosition(engine.screenWidth - self.w, 0)
  self:setBackground("standard_window")
  self:add("route", engine.prefab.route_box:new())
  self:add("goods", engine.prefab.item_box:new(), self:stackUnder("route", 2))
  
  local btnWidth = (self.w - 15) / 2
  self:add("name_label", newNameLabel(5, self:stackUnder("goods", 2), btnWidth))
  self:add("name", newTextInput(self:stackRight("name_label", 2), self:stackUnder("goods", 2), btnWidth))
  self:add("save", newSaveButton(self:stackUnder("name", 2), btnWidth))
  self:add("load", newLoadButton(self:stackRight("save", 5), self:stackUnder("name", 2), btnWidth))
end

return route