local WIDTH = 256
local HEIGHT = 209
local black = engine.ui.colour.black
local bPic = "standard_button"
local hPic = bPic.."_hover"

local function addSaveButton(label, y)
  local b = engine.ui.button:extend()
        function b:onClick(x, y, b)
          self.win.saveName = label
          self.isSelected = true
          self.win.isDirty = true
        end
  return b:new(label, 5, y + 3, WIDTH - 20, 32, bPic, hPic, engine.system.vars.user.uiText, true)
end

local saveBox = engine.ui.container:extend()
      function saveBox:setup()
        local y = 1
        local dir = love.filesystem.getDirectoryItems("/Saves")
        for _, file in pairs(dir) do
          self:add(file, addSaveButton(file, y))
          y = y + 33
        end
      end

local saveBtn = engine.ui.button:extend()
      function saveBtn:onClick(x, y, b)
        local folder = self.win.saveName
        if game.world ~= nil then
          engine.commands.save(folder)
          engine.state.set("game_menu")
          engine.lastState = "game"
        end
      end

local backBtn = engine.ui.button:extend()
      function backBtn:onClick(x, y, b)
        engine.state.set("game_menu")
        engine.lastState = "game"
      end

local save = engine.ui.window:extend()

function save:setup()
  self.label = "Save"
  self.saveName = "autosave"
  local tCol = engine.system.vars.user.uiText
  local cx = (engine.screenWidth - WIDTH) / 2
  local cy = (engine.screenHeight - HEIGHT) / 2
  local wid = math.floor((WIDTH - 10) / 2)
  self:setPosition(cx, cy)
  self:setSize(WIDTH, HEIGHT)
  self:setBackground("standard_window")
  self:add("save_box", saveBox:new("Save Box", 5, self.headerHeight - 2, WIDTH - 10, (32 * 4) + 12, "standard_container", "standard_container_hover", tCol, true))
  self:add("save", saveBtn:new("Save Game", 5, self:stackUnder("save_box", 1), wid, 32, bPic, hPic, tCol, true))
  self:add("cancel", backBtn:new("Cancel", self:stackRight("save", 0), self:stackUnder("save_box", 1), wid, 32, bPic, hPic, tCol, true))
end

function save:update(dt)
  local x = (engine.screenWidth - WIDTH) / 2
  local y = (engine.screenHeight - HEIGHT) / 2
  self:setPosition(x, y)
end

return save