local WIDTH = 300 - 9
local BTNWID = 300 - 36 - 32
local BTNHIG = 16

local fileList = engine.ui.container:extend()

function fileList:newImg(x, y, key)
  local img = engine.ui.button:extend()
        img.isPicture = true
        function img:onClick(x, y, b)
          self.win.filename = key
        end
  return img:new(key.."_img_icon", x, y, 16, 16, "image_icon", "image_icon", {0,0,0,0})
end

function fileList:newLabel(x, y, key)
  local lab = engine.ui.button:extend()
        function lab:setup()
          self.align = "left"
          self:setTileDimensions(32, 16, 96, 16)
        end
        function lab:onClick(x, y, b)
          self.win.filename = key
          if self.isSelected then
            self.isHovered = true
          end
        end
        function lab:onScroll(s)
          if s > 0 then
            self.box.objects.scroll_bar:decrease()
          else
            self.box.objects.scroll_bar:increase()
          end
        end
  return lab:new(key, x, y, BTNWID, BTNHIG, "standard_spreadsheet_tile", "standard_spreadsheet_tile_hover", engine.system.vars.user.uiText, true)
end

function fileList:addButtons()
  local YPAD = 5
  local list = {}
  for k, v in pairs(engine.assets) do table.insert(list, k) end
  table.sort(list)
  for i = 1, #list do
    local XPAD = 5
    self:add(list[i].."_img_icon", self:newImg(XPAD, YPAD, list[i]))
    self:add(list[i].."_label", self:newLabel(self:stackRight(list[i].."_img_icon", 0), YPAD, list[i]))
    YPAD = YPAD + 16
  end
end

function fileList:setup(folder)
  self.folder = folder
  self.label = "Open"
  self:setSize(WIDTH, 300)
  self:setPosition(5, 30)
  self:setBackground("standard_container")
  self:addButtons()
end

return fileList