local preview = engine.ui.container:extend()

function preview:setup()
  self.label = "Image Preview"
  self:setSize(128, 128)
  self:setPosition(5, self.win:stackUnder("file_list", 2))
  self.win:centerObject(self.key, "h")
  self:setBackground("standard_container")
end

function preview:update()
  if self.win.filename ~= nil then
    local lastCanvas = self:getCanvas()
    love.graphics.clear(0,0,0,0)
    self:drawBackground()
    local x = math.floor((self.w / 2) - (engine.assets[self.win.filename]:getWidth() / 2)) + .5
    local y = math.floor((self.h / 2) - (engine.assets[self.win.filename]:getHeight() / 2)) + .5
    love.graphics.setColor(255,255,255,255)
    love.graphics.draw(engine.assets[self.win.filename], x, y)
    love.graphics.setCanvas(lastCanvas)
    self.isDirty = false
  end
end

return preview