local cBtn = engine.ui.button:extend()
      function cBtn:onClick(x, y, b)
        self.win.objects[self.boxId].colour = self.bCol
        self.win.objects[self.boxId].colourChange = true
      end

local sBtn = engine.ui.button:extend()
      function sBtn:onClick(x, y, b)
        if b == 1 then
          self.win.selectedCol = self.bCol
        elseif b == 2 then
          self.win.secondaryCol = self.bCol
        end
      end

local qPalette = engine.ui.container:extend()
      qPalette.colourList = {
        engine.ui.colour.black,
        engine.ui.colour.white,
        engine.ui.colour.red,
        engine.ui.colour.green,
        engine.ui.colour.blue,
        {0,255,255,255},
        {255,128,0,255},
        {255,255,0,255},
        }
      function qPalette:setup()
        local xOff = 15
        local yOff = 7
        local btnWid = 32
        local btnHig = 32
        local space = 2
        local white = engine.ui.colour.white
        for i = 1, 8 do
          local col = self.colourList[i]
          self:add("colour_"..i, cBtn:new("", xOff, yOff, btnWid, btnHig, col, col, col))
          xOff = xOff + btnWid + space
        end
        xOff = 15
        yOff = yOff + btnHig + space
        for i = 1, 8 do
          self:add("shade_"..i, sBtn:new("", xOff, yOff, btnWid, btnHig, white, white, white))
          xOff = xOff + btnWid + space
        end
        self:setSize(300, 112)
        self.colour = white
        self.colourChange = true
      end
      function qPalette:setShades(col)
        for i = 1, 8 do
          local mod = i * (1 / 8)
          local shade = engine.ui.colour.shade(col, mod)
          self.objects["shade_"..i]:setBackground(shade)
        end
        self.isDirty = true
      end
      function qPalette:update(dt, mx, my)
        if self.colourChange then
          self:setShades(self.colour)
          self.colourChange = false
        end
      end
      
return qPalette