--Current Selection setup...

local currentBtn = engine.ui.button:extend()
      function currentBtn:update(dt, mx, my)
        self:setBackground(self.win.selectedCol)
        self.box.isDirty = true
      end

local otherBtn = engine.ui.button:extend()
      function otherBtn:update(dt, mx, my)
        self:setBackground(self.win.secondaryCol)
        self.box.isDirty = true
      end

--Palette Window setup...
local palette = engine.ui.window:extend()

function palette:setup()
  local wid, hig = 320, 500
  local trans = engine.ui.colour.transparent
  local black = engine.ui.colour.black
  local white = engine.ui.colour.white

  self.label = "Palette"
  self.horiSliderCol = {255,0,0,255}
  self.vertSliderCol = {255,255,255,255}
  self:setPosition(100, 100)
  self:setSize(wid, hig)
  self:setBackground("standard_window")
  self:setHoverColour("standard_window")
  self:setTextColour(white)
  
  self.selectedCol = black
  self.secondaryCol = white
  self:add("picker", engine.prefab.colour_picker:new("picker", 6, self.headerHeight - 2, 300, 300, "standard_container", "standard_container_hover", trans, true))
  self:add("select", engine.prefab.fast_palette:new("select", 8, self:stackUnder("picker", 1), 274, 72, "standard_container", "standard_container_hover", trans, true))
  self:add("current", engine.ui.container:new("current", 1, self:stackUnder("select", 1) - 32, 80, 80, "standard_container", "standard_container_hover", trans, true))
  self.objects.current:add("right", otherBtn:new("", 33, 33, 32, 32, white, white, white))
  self.objects.current:add("left", currentBtn:new("", 15, 15, 32, 32, black, black, black))
  self:centerObject("picker", "h")
  self:centerObject("select", "h")
  self:centerObject("current", "h")
end

function palette:update(dt)
  if self.isHovered then
    self.isDirty = false
  end
end

return palette