--Tool button setup...

local saveBtn = engine.ui.button:extend()
      function saveBtn:onClick(x, y, b)
        engine.state.sprite_edit.saveImage()
      end

local newBtn = engine.ui.button:extend()
      function newBtn:onClick(x, y, b)
        engine.state.sprite_edit.newCanvas()
      end

local widSlide = engine.ui.slider:extend()
      function widSlide:defineBounds()
        self.dataLookup = engine.state.sprite_edit.dataLookup
        self:setLimits(1, #self.dataLookup, 1)
        self:setValue(math.floor(#self.dataLookup / 2) + 1)
      end
      function widSlide:onValueChange()
        engine.state.sprite_edit.canvasSizeX = self:getValue()
        engine.state.sprite_edit.newCanvas()
      end
      
local higSlide = widSlide:extend()
      function higSlide:onValueChange()
        engine.state.sprite_edit.canvasSizeY = self:getValue()
        engine.state.sprite_edit.newCanvas()
      end

local nameBox = engine.ui.input_box:extend()
      nameBox.text = "Untitled"
      function nameBox:update()
        engine.system.vars.user.currentFileName = self.text
      end

--Toolbar setup
local toolbar = engine.ui.window:extend()

function toolbar:setup()
  local wid, hig = 256, 288
  local border = 8
  local white = engine.ui.colour.white
  local cyan = engine.ui.colour.cyan
  local hCyan = engine.ui.colour.shade(cyan, .8)
  local black = engine.ui.colour.black
  local trans = {0,0,0,0}
  self.label = "Tools"
  self.currentTool = "pencil"
  self:setPosition(engine.screenWidth - wid, engine.screenHeight - hig - 10)
  self:setSize(wid, hig)
  self:setBackground("standard_window")
  self:setTextColour(white)
  self:add("tool_buttons", engine.prefab.tool_tabs:new("Tools", 1, self.headerHeight - 2, 250, 96, "standard_container", "standard_container_hover", white, true))
  self:add("save_button", saveBtn:new("Save", border / 2, self:stackUnder("tool_buttons", 1), wid - border, 32, "standard_button", "standard_button_hover", white, true))
  self:add("w_label", engine.ui.label:new("Width", border / 2, self:stackUnder("save_button", 1), wid - border, 17, trans, trans, white))
  self:add("width_slider", widSlide:new("Width", border / 2, self:stackUnder("w_label", 1), wid - border, 32, "standard_slider", "standard_slider", white, true))
  self:add("h_label", engine.ui.label:new("Height", border / 2, self:stackUnder("width_slider", 1), wid - border, 17, trans, trans, white))
  self:add("height_slider", higSlide:new("Height", border / 2, self:stackUnder("h_label", 1), wid - border, 32, "standard_slider", "standard_slider", white, true))
  self:add("new_button", newBtn:new("New", border / 2, self:stackUnder("height_slider", 1), wid - border, 32, "standard_button", "standard_button_hover", white, true))
  self:add("name_label", engine.ui.label:new("Filename", border / 2, self:stackUnder("new_button", 1), 60, 32, trans, trans, white))
  self:add("name_box", nameBox:new("name", self:stackRight("name_label", 2), self:stackUnder("new_button", 1), wid - border - 62, 32, "standard_button", "standard_button_hover", white, true))
  self:centerObject("tool_buttons", "h")
end

return toolbar