local debug = {}

function debug.time()
  local date = os.date("!*t")
  for k, v in pairs(date) do
    if #tostring(v) < 2 then
      date[k] = "0"..v
    end
  end
  local time = "["..date.day.."/"..date.month.."/"..string.sub(date.year, 3, 4).."] "..date.hour..":"..date.min..":"..date.sec
  return time
end

function debug.checkFilter(filter)
  local fFound = false
  if debug.filters == nil then
    debug.filters = {}
  end
  local fc = #debug.filters + 1 or 1
  for i = 1, #debug.filters do
    if debug.filters[i] == filter then
      fFound = true
      break
    end
  end
  if not fFound then
    debug.filters[fc] = filter
  end
end

function debug.add(text, filter)
  --if debug.data == nil then
    --debug.data = {}
  --end
  if filter == nil then filter = "Main" end
  --local c = #debug.data + 1 or 1
  local str = debug.time().." "..filter..": "..text
  if debug.lastString == str then return end
  debug.lastString = str
  --debug.data[c] = {}
  --debug.data[c].filter = filter
  --debug.data[c].text = str
  --debug.checkFilter(filter)
  print(str)
end

function debug.draw()
  if debug.data ~= nil then
    love.graphics.setColor(0, 255, 0, 255)
    local c = 0
    for i = #debug.data, #debug.data - 20, -1 do
      if debug.data[i]~= nil then
        love.graphics.print(debug.data[i].text, 0, c)
        c = c + 16
      end
    end
  end
end

function debug.dump()
  if not love.filesystem.exists("Debug") then
    love.filesystem.createDirectory("Debug")
  end
  local dbgData = love.filesystem.newFile("Debug/last_run.txt")
  dbgData:open("w")
  for i = 1, #debug.data do
    dbgData:write(debug.data[i].text.."\r\n")
  end
  dbgData:close()
end

return debug