local s = {}

function s.serialize(t, spacing)
  if spacing == nil then spacing = "" end
  local str = "{ \n"
  spacing = spacing.."  "
  for k, v in pairs(t) do
    local key = k.." = "
    if tonumber(k) then
      key = ""
    end
    if type(v) == "string" then
      str = str..spacing..key.."'"..v.."',\n"
    elseif type(v) == "number" then
      str = str..spacing..key..tostring(v)..",\n"
    elseif type(v) == "table" then
      str = str..spacing..key..s.serialize(v, spacing)..",\n"
    end
  end
  str = str..spacing.."}"
  return str
end

function s.save(data, folder, label)
  love.filesystem.createDirectory("Saves/"..folder)
  local save = love.filesystem.newFile("Saves/"..folder.."/"..label..".lua", "w")
  save:write("return "..s.serialize(data))
  save:close()
  dbg.add(folder.."/"..label, "SAVE")
end

return s