local checkBox = engine.ui.button:extend()

function checkBox:internalSetup()
  self.type = "checkbox"
  self.isChecked = false
end

function checkBox:mouseReleased(x, y, b)
  self.isGrabbed = false
  if self.isVisible then
    if self:checkHovered(x, y) then
      if self.box ~= nil then self.box.isDirty = true end
      if self.win ~= nil then self.win.isDirty = true end
      if self.isChecked then
        self:onUncheck()
      else
        self:onCheck(x, y, b)
      end
      self.isChecked = not self.isChecked
      return true
    else
      if self.isSelected then
        self.isDirty = true
      end
      self.isSelected = false
    end
  end
  return false
end

function checkBox:onCheck() end

function checkBox:onUncheck() end

function checkBox:drawBackground()
  local x, y = self:getPosition()
  if self.box ~= nil then
    y = y - self.box.scrollY
  end
  if self.image ~= nil then
    if self.isPicture then
      engine.ui.colour.set("white")
    else
      engine.ui.colour.set(engine.system.vars.user.uiColour)
    end
    if self.isTiled then
      self:tileBackground()
    else
      local image = self.image
      if self.isChecked then
        image = self.hoverImage
      end
      love.graphics.draw(engine.assets[image], x, y)
      if self.isHovered then
        engine.ui.colour.set(self.hoverColour or "black")
        love.graphics.rectangle("line", x, y, self.w, self.h)
      end
    end
  else
    engine.ui.colour.set(self.bCol)
    love.graphics.rectangle("fill", x, y, self.w, self.h)
  end
  if self.hoverImage == self.image and self.isHovered then
    engine.ui.colour.set(self.hoverColour or "black")
    love.graphics.rectangle("line", x, y, self.w, self.h)
  end
end

return checkBox