local colour = {
  transparent = {0,0,0,0},
  black = {0,0,0,255},
  white = {255,255,255,255},
  grey = {150,150,150,255},
  red = {255,0,0,255},
  green = {0,255,0,255},
  blue = {0,0,255,255},
  }

function colour.add(label, col)
  colour[label] = col
end

function colour.shade(col, hue)
  local rCol = {}
  if hue == nil then hue = 1 end
  if type(col) == "string" then
    rCol = {colour[col][1] * hue, colour[col][2] * hue, colour[col][3] * hue, colour[col][4]}
  else
    rCol = {col[1] * hue, col[2] * hue, col[3] * hue, col[4]}
  end
  return rCol
end

function colour.blend(col1, col2, bias)
  local bias2 = 1 - bias
  if type(col1) == "string" then
    col1 = colour[col1]
  end
  if type(col2) == "string" then
    col2 = colour[col2]
  end
  return {
    ((col1[1] * bias) + (col2[1] * bias2)),
    ((col1[2] * bias) + (col2[2] * bias2)),
    ((col1[3] * bias) + (col2[3] * bias2)),
    ((col1[4] * bias) + (col2[4] * bias2)),
    }
end

function colour.set(col, hue)
  if col == nil then col = colour.white end
  if hue == nil then hue = 1 end
  if type(col) == "string" then
    love.graphics.setColor(colour[col][1] * hue, colour[col][2] * hue, colour[col][3] * hue, colour[col][4])
  else
    love.graphics.setColor(col[1] * hue, col[2] * hue, col[3] * hue, col[4])
  end
end

colour.add("cyan", colour.blend("green", "blue", .5))
colour.add("purple", colour.blend("red", "blue", .5))
colour.add("yellow", colour.blend("red", "green", .5))

return colour