local dd = engine.ui.button:extend()

function dd:internalSetup()
  local grey = engine.ui.colour.grey
  local lGrey = engine.ui.colour.shade(grey, .8)
  local black = engine.ui.colour.black
  self.type = "drop_down"
  self.container = engine.ui.container:new("box", 1, 1, 10, 10, grey, lGrey, black)
  self.container:toggleVisible()
  self.isOpen = false
end

function dd:setSlideDirection(dir)
  if dir == nil then dir = "down" end
  self.slideDirection = dir
end

function dd:getLongest()
  if self.container ~= nil then
    local longest = self.w
    local height = 20
    for k, v in pairs(self.container.objects) do
      local objWidth = font:getWidth(self.container.objects[k].label)
      if objWidth > longest then
        longest = objWidth
      end
    end
    for k, v in pairs(self.container.objects) do
      self.container.objects[k].w = longest + 10
    end
    self.container:setSize(longest + 10, 50)
  end
end

function dd:add(key, obj)
  self.container:add(key, obj)
  self:getLongest()
end

function dd:mousePressed(x, y, b)
  if self.container:mousePressed(x, y, b) then return true end
  if self:checkHovered(x, y) then
    self.grabx = x - self.x
    self.graby = y - self.y
    self.isGrabbed = true
    self.isDirty = true
    return true
  end
  return false
end

function dd:onClick(x, y, b)
  self.container:toggleVisible()
end

function dd:update(dt, mx, my)
  self.container:setPosition(self.x, self.y + self.h)
  self.container:update(dt, mx, my)
end

function dd:draw()
  self:drawBackground()
  self.container:draw()
end

return dd