local cam = engine.ui.asset:extend()

function cam:init(label, id, x, y, w, h)
  self.isVisible = true
  self.isHovered = false
  self.isMoveable = false
  self.isGrabbed = false
  self.isSelected = true
  self.isDirty = true
  self.type = "camera"
  self.label = label
  self:setPosition(x, y)
  self:setSize(w, h)
  self.canvasId = label.."_"..id
  game.world:addCamera(self.canvasId, engine.system.camera:new(0, 0, self.w, self.h, .05))
  game.world.cameras[self.canvasId]:setTarget(id)
end

function cam:update(dt)
  self.isDirty = true
end

function cam:draw()
  local lastCanvas = self:getCanvas()
  if game.world.cameras[self.canvasId] ~= nil then
    love.graphics.setColor(255,255,255,255)
    love.graphics.draw(game.world.cameras[self.canvasId].canvas, self.x, self.y)
  end
  love.graphics.setCanvas(lastCanvas)
end

return cam