--Input Buttons...

local dnBtn = engine.ui.button:extend()
      function dnBtn:onClick(x, y, b)
        dbg.add(self.boxId.." Clicked")
        self.box:increase()
      end

local upBtn = engine.ui.button:extend()
      function upBtn:onClick(x, y, b)
        dbg.add(self.boxId.." Clicked")
        self.box:decrease()
      end

local slBtn = engine.ui.button:extend()
      function slBtn:setup()
        self:toggleMoveable()
      end
      function slBtn:update(dt, mx, my)
        local boxId = self.boxId
        local w, h = self.box:getSize()
        local miny = self.box.quadSize
        local maxy = h - (miny * 2)
        if self.x ~= 0 then self.x = 0 end
        if self.y < miny then self.y = miny end
        if self.y > maxy then self.y = maxy end
        if self.isGrabbed and self.isHovered == false then
          self.box:getPositionValue(self.x, self.y)
          self.isGrabbed = false
        end
      end
      function slBtn:onClick(x, y, b)
        self.box:getPositionValue(self.x, self.y)
      end
      function slBtn:onScroll(s)
        dbg.add("Slider scrolled: "..s, "Slider")
        if s > 0 then
          self.box:decrease()
        else
          self.box:increase()
        end
      end

--Slider Main...

local slider = engine.ui.slider:extend()
      slider.quadSize = 32
      slider.imageWidth = 96
      slider.imageHeight = 32
      slider.quads = {
        left = love.graphics.newQuad(0, 0, slider.quadSize, slider.quadSize, slider.imageWidth, slider.imageHeight),
        mid = love.graphics.newQuad(slider.quadSize, 0, slider.quadSize, slider.quadSize, slider.imageWidth, slider.imageHeight),
        right = love.graphics.newQuad(2 * slider.quadSize, 0, slider.quadSize, slider.quadSize, slider.imageWidth, slider.imageHeight),
      }

function slider:defineBounds()
  self.value = 1
  self.minValue = 1
  self.maxValue = 8
  self.incValue = 1
end

function slider:setup()
  local btnW = self.quadSize
  if self.image ~= nil then
    local image = self.image
    dbg.add(image.."_back selected.", "Draw")
    self:setBackground(image.."_back")
    self:setHoverColour(image.."_back_hover")
    self:setTextColour(tCol)
    self:add("val_dn", dnBtn:new("", 0, self.h - btnW, btnW, btnW, image.."_button_down", image.."_button_down_hover", self.tCol))
    self:add("val_up", upBtn:new("", 0, 0, btnW, btnW, image.."_button_up", image.."_button_up_hover", self.tCol))
    self:add("val_sl", slBtn:new(self.value, -1, btnW, btnW, btnW, image.."_button", image.."_button_hover", self.tCol))
  else
    self:setBackground(bCol)
    self:setHoverColour(hCol)
    self:setTextColour(tCol)
    self:add("val_dn", dnBtn:new("+", 0, 0, btnW, btnW, self.bCol, self.hCol, self.tCol))
    self:add("val_up", upBtn:new("-", 0, self.h - btnW + 1, btnW, h, self.bCol, self.hCol, self.tCol))
    self:add("val_sl", slBtn:new("_", 1, btnW, btnW, btnW, self.bCol, self.hCol, self.tCol))
  end
end

function slider:getPositionValue(x, y)
  if self.isHovered then
    local w, h = self:getSize()
    local miny = self.quadSize
    local maxy = h - (miny * 2)
    local minVal, maxVal = self:getLimits()
    local inc = self.incValue
    local notches = ((maxVal - minVal) / inc) + 1
    local notchHeight = (maxy - miny) / notches
    local notchPos = math.floor(y / notchHeight)
    self:setValue(notchPos * inc)
  end
end

function slider:getValuePosition(val)
  local w, h = self:getSize()
  local miny = self.quadSize
  local maxy = h - (miny * 2)
  local minVal, maxVal = self:getLimits()
  local inc = self.incValue
  local range = maxVal - minVal
  local notches = range / inc
  local currentNotch = (self.value / inc)
  local notchHeight = (maxy - miny) / notches
  local yPos = miny + (currentNotch * notchHeight)
  self.objects["val_sl"]:setPosition(0, yPos)
end

function slider:tileBackground()
  local angle = math.rad(90)
  local image = self.image
  local x, y = self.quadSizeX, 0
  local w, h = self:getSize()
  local size = self.quadSizeX
  local scaleX = (h - (2 * self.quadSizeY)) / self.quadSizeY
  local scaleY = w / self.quadSizeX
  love.graphics.setColor(engine.system.vars.user.uiColour)
  if self.isHovered or self.isSelected and self.hoverImage ~= nil then
    image = self.hoverImage
  end
  love.graphics.draw(engine.assets[image], self.quads.mid, x, y + self.quadSizeY, angle, scaleX, scaleY)
  love.graphics.draw(engine.assets[image], self.quads.left, x, y, angle)
  love.graphics.draw(engine.assets[image], self.quads.right, x, h - y - self.quadSizeY, angle)
end

function slider:onScroll(s)
  if s > 0 then
    self:decrease()
  else
    self:increase()
  end
end

return slider